<?php
if ( function_exists('register_sidebar') )
        register_sidebar(array(
		'name' => 'sidebar',
        'before_widget' => '<div class="sidebar">',
        'after_widget' => '</div>',
        'before_title' => '<h3>',
        'after_title' => '</h3><div class="line"></div>',
    ));
add_filter( 'the_category', 'add_nofollow_cat' ); 
function add_nofollow_cat( $text ) {
$text = str_replace('rel="category"', "", $text); return $text;
}  ;

function excerpt($limit) {
  $excerpt = explode(' ', get_the_excerpt(), $limit);
  if (count($excerpt)>=$limit) {
    array_pop($excerpt);
    $excerpt = implode(" ",$excerpt).'...';
  } else {
    $excerpt = implode(" ",$excerpt);
  }	
  $excerpt = preg_replace('`\[[^\]]*\]`','',$excerpt);
  return $excerpt;
}

function content($limit) {
  $content = explode(' ', get_the_content(), $limit);
  if (count($content)>=$limit) {
    array_pop($content);
    $content = implode(" ",$content).'...';
  } else {
    $content = implode(" ",$content);
  }	
  $content = preg_replace('/\[.+\]/','', $content);
  $content = apply_filters('the_content', $content); 
  $content = str_replace(']]>', ']]&gt;', $content);
  return $content;
}
//自訂Menu
register_nav_menus( array('primary' => __( 'Primary Navigation', 'itw' ),) );
//特色圖片
if ( function_exists( 'add_theme_support' ) ) {
	add_theme_support( 'post-thumbnails' );
}
//插入Facebook Meta
function insert_fbmeta() {
	global $post;
	if ( is_home()) {
//如果是首頁的話就抓這張圖片，可以自己設定Logo圖片
	$ogimage = get_option('itw_ogimage');
	if($ogimage) { 
	echo '<meta property="og:image" content="'.$ogimage.'" />' ;
	echo "\n";
	}
	$fbadmin = get_option('itw_fbadmin');
	if($fbadmin) { 
	echo '<meta property="fb:admins" content="'.$fbadmin.'" />';//管理員ID
	echo "\n";
	}
	$fbappid = get_option('itw_fbappid');
	if($fbappid) { 
    echo '<meta property="fb:app_id" content="'.$fbappid.'" />';//APP_ID
	echo "\n";
	}
    echo '<meta property="og:title" content="' ; bloginfo('name'); echo '"/>';//標題
	echo "\n";
    echo '<meta property="og:description" content="' ; bloginfo('description'); echo '"/>';//截取字數	
	echo "\n";
    echo '<meta property="og:url" content="' ; bloginfo('url'); echo '"/>';//連結
	echo "\n";	
    echo '<meta property="og:site_name" content="'; bloginfo('name'); echo '"/>';//網站名稱	
	echo "\n";
	}
//判斷是否為內文頁面，不是則不繼續
	if ( !is_singular()) 
	return;
//如果有特色圖片就使用
	global $post, $posts;
	$img = '';
	$post_thumbnail_id = get_post_thumbnail_id( $id );
	if($post_thumbnail_id){
		$output = wp_get_attachment_image_src( $post_thumbnail_id, 'large' );
		$img = $output[0];
	}
//如果沒有特色圖片，使用文章內的第一張圖片
	else { 
		ob_start();
		ob_end_clean();
		$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $img2);
		$img = $img2 [1] [0];
//如果文章內沒有圖片，使用網站預設Logo
		if(empty($img)){
			$ogimage = get_option('itw_ogimage');
			if($ogimage) { 
				$img = $ogimage;
			}
		}
	}
//插入Meta	
	echo "\n";
	$fbadmin = get_option('itw_fbadmin');
	if($fbadmin) { 
	echo '<meta property="fb:admins" content="'.$fbadmin.'" />';//管理員ID
	echo "\n";
	}
	$fbappid = get_option('itw_fbappid');
	if($fbappid) { 
	echo '<meta property="fb:app_id" content="'.$fbappid.'" />';//APP_ID
	echo "\n";
	}
	echo '<meta property="og:title" content="' . get_the_title() . '"/>';//標題
	echo "\n";
	echo '<meta property="og:description" content="' . mb_strimwidth(strip_tags(apply_filters("the_content", $post->post_content)), 0, 200,"...") . '"/>';//截取字數	
	echo "\n";		
	echo '<meta property="og:type" content="article"/>';//內容格式
	echo "\n";
	echo '<meta property="og:url" content="' . get_permalink() . '"/>';//連結
	echo "\n";	
	echo '<meta property="og:site_name" content="' ; bloginfo('name'); echo '"/>';//網站名稱	
	echo "\n";
	$thumbnail = get_option('itw_thumbnail');
	if($thumbnail) { 
	echo '<meta property="og:image" content="'.$img.'" />' ;//圖片
	echo "\n";
	}
}
add_action( 'wp_head', 'insert_fbmeta', 10 );

//Navigation Page
function pagenavi( $p = 2 ) { // pages will be show before and after current page
  if ( is_singular() ) return; // don't show in single page
  global $wp_query, $paged;
  $max_page = $wp_query->max_num_pages;
  if ( $max_page == 1 ) return; // don't show when only one page
  if ( empty( $paged ) ) $paged = 1;
  //echo '<span class="totalpages">Page: ' . $paged . ' of ' . $max_page . ' </span> '; // page location
  if ( $paged > $p + 1 ) p_link( 1, 'First' );
  if ( $paged > $p + 2 ) echo '... ';
  for( $i = $paged - $p; $i <= $paged + $p; $i++ ) { // Middle pages
    if ( $i > 0 && $i <= $max_page ) $i == $paged ? print "<span class='page-numbers current'>{$i}</span> " : p_link( $i );
  }
  if ( $paged < $max_page - $p - 1 ) echo '... ';
  if ( $paged < $max_page - $p ) p_link( $max_page, 'Last' );
}
function p_link( $i, $title = '' ) {
  if ( $title == '' ) $title = "Page {$i}";
  echo "<a class='page-numbers' href='", esc_html( get_pagenum_link( $i ) ), "' title='{$title}'>{$i}</a> ";
}
//Author Description
function add_more_profile( $contactmethods ) {
    $contactmethods['facebook'] = 'Facebook';
    $contactmethods['twitter'] = 'Twitter';
    $contactmethods['plus'] = 'Google Plus';
    $contactmethods['describe'] = '關於作者';
  	if ( isset( $contactmethods['yim'] ) )
    unset( $contactmethods['yim'] );
  	if ( isset( $contactmethods['aim'] ) )
    unset( $contactmethods['aim'] );
    return $contactmethods;
}
add_filter( 'user_contactmethods', 'add_more_profile', 10, 1 );

//More後的廣告
$ads3 = get_option('itw_ads3');
if($ads3) { 
	add_filter('the_content', 'more_ads');
	function more_ads($text){
		if (is_single())
		global $post;
		$thePostID = $post->ID;
		$more_insert = '<span id="more-' .$thePostID.'"></span>' ;
 		return str_replace($more_insert, more_code(), $text);
 	}
	function more_code(){
		$ads3 = get_option('itw_ads3');
		return '<div class="ads3"><div class="tabledisplay"><div class="adscen">
		'.stripslashes($ads3).'
		</div></div></div>';
	}
}

/*隨機文章*/
function twweeb_random_lists($num_limit = 6 , $exclude = "" , $date_limit = "" , $echo = true , $list = true){
        $out = "";
        if ( $num_limit < 1 ) $num_limit = "-1";
        if ( !$date_limit_ts = strtotime($date_limit) ) $date_limit = false;
        if ( !$date_limit ){
            $posts = get_posts('offset=0&numberposts='.$num_limit.'&exclude='.$exclude.'&orderby=rand');
        } else {
            $posts = get_posts('offset=0&numberposts=-1&exclude='.$exclude.'&orderby=rand');
        }
        $postscount = count($posts);
        if ( $num_limit < 1 ) $num_limit = $postscount;
        if ( $postscount < $num_limit ) $num_limit = $postscount ;
        for ( $i = 0 ; $i < $num_limit ; $i++ ){
             if ( !$date_limit or $date_limit_ts < strtotime( $posts[$i]->post_date )){
                if ( $list ) $out.= '<li class="random-post-link">'."\n";
                  $out.= '<a href="'.get_permalink($posts[$i]->ID).'" title="'.$posts[$i]->post_title.'">'.$posts[$i]->post_title.'</a>'."\n";
                if ( $list ) $out.= '</li>'."\n";
            }else{
                if ( $postscount > $num_limit ) $num_limit++;
            }
        }
        if ( $list ) $out = '<ul class="random-post-link">'."\n".$out.'</ul>'."\n";
        if ( $echo ){
              echo $out;
        } else {
            return $out;
        }
    }
?>